# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: app.py 16250 2009-06-17 13:29:20Z ctheune $

import grok
import zope.dublincore.interfaces

import gocept.genericskin.interfaces

import gocept.directory.interfaces
import gocept.directory.exportposix
import gocept.directory.persons
import gocept.directory.unixaccounts
import gocept.directory.customers
import gocept.directory.posixids


uid_field = gocept.directory.interfaces.IUnixAccount['uid']
gid_field = gocept.directory.interfaces.IResourceGroup['gid']


class Directory(grok.Application, grok.Container):

    grok.local_utility(gocept.directory.persons.Persons,
                       provides=gocept.directory.interfaces.IPersons,
                       public=True, name_in_container='persons')
    grok.local_utility(gocept.directory.unixaccounts.UnixAccounts,
                       provides=gocept.directory.interfaces.IUnixAccounts,
                       public=True, name_in_container='unixaccounts')
    grok.local_utility(gocept.directory.customers.Customers,
                       provides=gocept.directory.interfaces.ICustomers,
                       public=True, name_in_container='customers')
    grok.local_utility(gocept.directory.posixids.POSIXIds,
                       provides=gocept.directory.interfaces.IPOSIXIds,
                       name='uid',
                       setup=lambda u: u.setup(uid_field.min, uid_field.max))
    grok.local_utility(gocept.directory.posixids.POSIXIds,
                       provides=gocept.directory.interfaces.IPOSIXIds,
                       name='gid',
                       setup=lambda u: u.setup(gid_field.min, gid_field.max))

    zope.interface.implements(gocept.directory.interfaces.IDirectory)

    paltry = None

    def traverse(self, name):
        if name == 'posix':
            return gocept.directory.exportposix.ExportPOSIX()
        # default behaviour if None is returned


@grok.subscribe(Directory, grok.IObjectAddedEvent)
def set_title(directory, event):
    dc = zope.dublincore.interfaces.IDCDescriptiveProperties(directory)
    dc.title = u'Directory'


class Index(grok.View):

    grok.layer(gocept.genericskin.interfaces.IGenericLayer)


class Edit(gocept.directory.form.BasicEditForm):
    pass
