# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: customer.py 16250 2009-06-17 13:29:20Z ctheune $

import grok
import zope.component

import gocept.directory.interfaces
import gocept.directory.resourcegroups
import gocept.directory.form


class Customer(grok.Container, grok.Site):

    grok.implements(gocept.directory.interfaces.ICustomer)
    persons = gocept.reference.ReferenceCollection(ensure_integrity=True)

    grok.local_utility(gocept.directory.resourcegroups.ResourceGroups,
                       provides=gocept.directory.interfaces.IResourceGroups,
                       public=True, name_in_container='resourcegroups')

    def __init__(self, id=u'', title=u''):
        super(Customer, self).__init__()
        self.id = id
        self.title = title
        self.persons = set()


class Index(gocept.directory.form.BasicEditForm):

    extra_content = u'@@containers'
    redirect_to_parent = False


class Containers(grok.View):

    def groups(self):
        resourcegroups = zope.component.getUtility(
            gocept.directory.interfaces.IResourceGroups)
        for group in resourcegroups.sorted_values():
            yield dict(title=gocept.directory.interfaces.ITitle(group),
                       url=self.url(group))

    def persons(self):
        for person in sorted(self.context.persons,
                             key=gocept.directory.interfaces.ITitle):
            yield dict(title=gocept.directory.interfaces.ITitle(person),
                       url=self.url(person))


@grok.implementer(gocept.directory.interfaces.ITitle)
def title_for_customer(customer):
    return customer.title
