# -*- coding: utf-8 -*-
# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id: form.py 16250 2009-06-17 13:29:20Z ctheune $

import grok
import os.path
import zope.app.container.interfaces
import zope.event
import zope.lifecycleevent
import zope.traversing.api


class BasicAddForm(grok.AddForm):

    grok.baseclass()
    template = grok.PageTemplateFile(os.path.join("templates", "form.pt"))
    extra_content = None

    # Needs to be set by the child class
    factory = None

    @grok.action("Add")
    def add(self, **data):
        obj = self.factory()
        zope.event.notify(zope.lifecycleevent.ObjectCreatedEvent(obj))
        self.applyData(obj, **data)
        chooser = zope.app.container.interfaces.INameChooser(self.context)
        name = chooser.chooseName('', obj)
        self.context[name] = obj
        self.redirect(self.url(self.context))

    @property
    def form_fields(self):
        return grok.AutoFields(self.factory)



class BasicEditForm(grok.EditForm):

    grok.baseclass()
    template = grok.PageTemplateFile(os.path.join("templates", "form.pt"))
    extra_content = None
    redirect_to_parent = True

    @grok.action("Apply")
    def handle_edit_action(self, **data):
        super(BasicEditForm, self).handle_edit_action.success(data)
        if not self.errors:
            self.flash(self.status)
            if self.redirect_to_parent:
                self.redirect(
                    self.url(zope.traversing.api.getParent(self.context)))
