# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt
# $Id$

import unittest
import zope.interface.verify
import zope.component
import zope.annotation.attribute
import gocept.reference.verify

import gocept.directory.customer
import gocept.directory.customers
import gocept.directory.interfaces
import gocept.directory.ipsubnet
import gocept.directory.ipsubnets
import gocept.directory.person
import gocept.directory.persons
import gocept.directory.resourcegroup
import gocept.directory.resourcegroups
import gocept.directory.posixids
import gocept.directory.storage
import gocept.directory.storages
import gocept.directory.unixaccount
import gocept.directory.unixaccounts


class TestInterfaces(unittest.TestCase):

    def setUp(self):
        zope.component.provideAdapter(
            zope.annotation.attribute.AttributeAnnotations)

    def test_person(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IPersons,
            gocept.directory.persons.Persons())
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IPerson,
            gocept.directory.person.Person())

    def test_customer(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.ICustomers,
            gocept.directory.customers.Customers())
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.ICustomer,
            gocept.directory.customer.Customer())

    def test_unixaccount(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IUnixAccounts,
            gocept.directory.unixaccounts.UnixAccounts())
        gocept.reference.verify.verifyObject(
            gocept.directory.interfaces.IUnixAccount,
            gocept.directory.unixaccount.UnixAccount())

    def test_resourcegroup(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IResourceGroups,
            gocept.directory.resourcegroups.ResourceGroups())
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IResourceGroup,
            gocept.directory.resourcegroup.ResourceGroup())

    def test_storage(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IStorages,
            gocept.directory.storages.Storages())
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IStorage,
            gocept.directory.storage.Storage())

    def test_ipsubnet(self):
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IIPSubnets,
            gocept.directory.ipsubnets.IPSubnets())
        zope.interface.verify.verifyObject(
            gocept.directory.interfaces.IIPSubnet,
            gocept.directory.ipsubnet.IPSubnet())


def test_suite():
    suite = unittest.TestSuite()
    suite.addTest(unittest.makeSuite(TestInterfaces))
    return suite
