# Copyright (c) 2008-2009 gocept gmbh & co. kg
# See also LICENSE.txt

import grok

import gocept.directory.interfaces
import gocept.reference


class UnixAccount(grok.Model):

    grok.implements(gocept.directory.interfaces.IUnixAccount)

    owner = gocept.reference.Reference(ensure_integrity=True,
                                       __name__='owner')

    def __init__(self, username=''):
        # the owner can only be set, after the object is added to its
        # parent
        self.username = username
        self.uid = None
        self.owner = None

    @property
    def gecos(self):
        """Return GECOS info for this account (from owner)."""
        if not self.owner:
            return ''
        return gocept.directory.interfaces.IGECOS(self.owner).fullname


@grok.implementer(gocept.directory.interfaces.ITitle)
def title_for_unixaccount(unixaccount):
    return '%s (%s)' % (unixaccount.username, unixaccount.uid)
